import java.net.*;
import java.io.*;
/**
 * Main part of the server.
 * @author Ernestas Kardzys (ernestaslt@gmail.com)
 * @version 0.1
 */
public class JavaServer {
	private static int port = 10000;	/* Default port*/
	
	//-------Test-----------
	private static int size = 4;
	private static PrintStream [] sessions = new PrintStream[size];
	//-------------------------
	public JavaServer() {
	}
	/**
	 * @param args Default arguments
	 */
	public static void main(String[] args) {
		try {
		    ServerSocket srv = new ServerSocket(port);
		    for(int i= 0; i < size; ++i) {
		    	sessions[i] = null;
			}
			
		    // Wait for connection from client.
		    System.out.println("Server is running....");
		    // ----- End of Server creation---------
		    Socket socket = srv.accept();
		    if (socket.isConnected()) {
		    	BasicShell shell = new BasicShell(socket);
		    	shell.helloMessage();
		    	System.out.println("[*] Got connection from " + socket.getLocalSocketAddress());
		    	// Our main message loop
		    	boolean exit = false;
		    	while (!exit) {
		    		try {
		    			BufferedReader rd = new BufferedReader(new InputStreamReader(socket.getInputStream()));
		    			String str =  rd.readLine();
		    			System.out.println("User entered: \"" + str + "\".");
		    			if (str.equals("exit")) {
		    				exit = true;
		    				break;
		    			}
		    			// Process commands
		    			shell.processCommand(str.toLowerCase());
		    			
		    		}
		    		catch (IOException e) {
		    			System.err.print(e.getMessage());
		    			e.printStackTrace();
		    		}
		    	}
		    socket.close();
	    	srv.close();
		    }
		}
		catch (BindException e){
			System.out.println("ERROR: BIND: Address is already in use!");
		}
		catch (IOException e) {
			System.err.println(e.getMessage());
			e.printStackTrace();
		}
		System.out.println("Server is down...");
		System.exit(0);
	}
}
